Attribute VB_Name = "DLLDef"
'-----------------------------------------------------------------------
'       aisa57.bas
'
'       aISA-A57 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' őXbg
Global Const AISA57_MAX_SLOTS = 16

' _Xbgw
Global Const AISA57_SLOT_AUTO = &HFFFF

' G[R[h̒`
Global Const AISA57_ERR_INTERNAL = 5100              ' Send mail to us
Global Const AISA57_ERR_UNKNOWN = 5101               ' Help me!
Global Const AISA57_SUCCESS = 0                      ' I
Global Const AISA57_ERR_NO_DEVICE = 5000             ' No device or not an aISA-A57
Global Const AISA57_ERR_RESOURCE = 5001              ' Resource exhaustion
Global Const AISA57_ERR_INVALID_ARG = 5002           ' Invalid argument(s)
Global Const AISA57_ERR_SLOT = 5003                  ' _Xbgԍsłi܂͌܂j
Global Const AISA57_ERR_CHANNEL = 5004               ' `lw肪sł
Global Const AISA57_ERR_TIMER = 5005                 ' ^C}lsł
Global Const AISA57_ERR_NOT_ENOUGH_MEM = 5006        ' \ȃmۂł܂ł
Global Const AISA57_ERR_NUMDATA = 5007               ' w肳ꂽ̃f[^obt@ɑ݂܂
Global Const AISA57_ERR_NOT_CREATED = 5008           ' foCXNGCgĂ܂
Global Const AISA57_ERR_START = 5009                 ' X^[gɎs܂B
Global Const AISA57_ERR_INVALID_FUNC = 5010          ' Ȋ֐Ăяoł
Global Const AISA57_ERR_IN_USE = 5011                ' gp̃foCXł(NT)

' TvO[h̒`
                                            ' START  SAMPLING  CLK
Global Const AISA57_MODE_01 = 1             ' soft   single    ---
Global Const AISA57_MODE_02 = 2             ' soft   burst     timer
Global Const AISA57_MODE_03 = 3             ' extrg  single    ---
Global Const AISA57_MODE_04 = 4             ' extrg  burst     timer

' bZ[W
' Aisa57Create  uWMBase ɐݒ肵lɂāAWM_EOC Ȃǂ
' ItZbglbZ[Wo܂B
#If WM_EOC Then
#Else
Global Const WM_EOC = 0                     ' VOTvO̊
Global Const WM_BUFF_HALF_FULL = 1          ' hCoOobt@̃n[tt
Global Const WM_BUFF_FULL = 2               ' hCoOobt@̃t
Global Const WM_BUFF_OVERFLOW = 3           ' hCoOobt@̃I[o[t[
Global Const WM_SAMPLING_OVERRUN = 4        ' `lEI[gECNg̃I[o[
#End If ' WM_EOC

' A/D`lݒl͈̔
Global Const AISA57_ADCH_FIRST = 0
Global Const AISA57_ADCH_LAST = 7

' A/D`lݒl
Global Const AISA57_ADCH_01 = 0
Global Const AISA57_ADCH_02 = 1
Global Const AISA57_ADCH_03 = 2
Global Const AISA57_ADCH_04 = 3
Global Const AISA57_ADCH_05 = 4
Global Const AISA57_ADCH_06 = 5
Global Const AISA57_ADCH_07 = 6
Global Const AISA57_ADCH_08 = 7

' D/A`lݒl
Global Const AISA57_DACH_01 = 0
Global Const AISA57_DACH_02 = 1

' I/O\[XzE
Global Const AISA57_MAX_MEM = 9                  ' MAX_MEM_REGISTERS
Global Const AISA57_MAX_IO = 20                  ' MAX_IO_PORTS
Global Const AISA57_MAX_IRQ = 7                  ' MAX_IRQS
Global Const AISA57_MAX_DMA = 7                  ' MAX_DMA_CHANNELS

' ***** I/O\[X\ *****
' YfoCXgpI/O\[XAvP[V󂯎邽߂̍\́B
Type AISA57RESOURCE
    dwNumMemWindows As Long                     ' EBhE
    dwMemBase(1 To AISA57_MAX_MEM) As Long      ' EBhEJnAhX
    dwMemLength(1 To AISA57_MAX_MEM) As Long    ' EBhE
    dwMemAttrib(1 To AISA57_MAX_MEM) As Long    ' EBhE
    dwNumIOPorts As Long                        ' I/O|[g
    dwIOPortBase(1 To AISA57_MAX_IO) As Long    ' I/O|[gJnAhX
    dwIOPortLength(1 To AISA57_MAX_IO) As Long  ' I/O|[g
    dwNumIRQs As Long                           ' IRQ
    dwIRQRegisters(1 To AISA57_MAX_IRQ) As Long ' IRQԍ
    dwIRQAttrib(1 To AISA57_MAX_IRQ) As Long    ' IRQ
    dwNumDMAs As Long                           ' DMA`l
    dwDMALst(1 To AISA57_MAX_DMA) As Long       ' DMA`l
    dwDMAAttrib(1 To AISA57_MAX_DMA) As Long    ' DMA`l
    dwReserved1(1 To 3) As Long                 ' \
End Type

' ***** TvO[h\ *****
' YfoCX̃TvO[hɊւDriver֓n߂̍\́B
' iChFirstiChLast𓯂lɂ邱ƂŃ`lEI[gECNgȂ[hƂȂB
Type AISA57MODE
    dwChFirst As Long       ' TvOJn`l(0 ` 7)
    dwChLast As Long        ' TvOI`l(0 ` 7)
    cwBuffer As Long        ' obt@TCYi[hPʁj
    dwTimer As Long         ' ^C}l(00H ` 3FH)
    dwMode As Long          ' 샂[h(1 ` 4)
End Type

'-----------------------------------------------------------
' API Functions
'-----------------------------------------------------------

Public Declare Function Aisa57GetVersion Lib "aisa57" (ByRef pdwDllVer As Long, ByRef pdwDrvVer As Long) As Long
Public Declare Function Aisa57Create Lib "aisa57" (ByRef pwLogSlot As Integer, ByVal hWnd As Long, ByVal uWMBase As Long, ByRef pvInitArg As Any) As Long
Public Declare Function Aisa57Close Lib "aisa57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa57GetResource Lib "aisa57" (ByVal wLogSlot As Integer, ByRef pres As AISA57RESOURCE) As Long
Public Declare Function Aisa57SetMode Lib "aisa57" (ByVal wLogSlot As Integer, ByRef pcmode As AISA57MODE) As Long
Public Declare Function Aisa57StartSampling Lib "aisa57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa57StopSampling Lib "aisa57" (ByVal wLogSlot As Integer) As Long
Public Declare Function Aisa57GetSamplingStatus Lib "aisa57" (ByVal wLogSlot As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Aisa57GetData Lib "aisa57" (ByVal wLogSlot As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Aisa57SetData Lib "aisa57" (ByVal wLogSlot As Integer, ByVal wChData As Integer, ByVal wDaData As Integer) As Long
Public Declare Function Aisa57InPort Lib "aisa57" (ByVal wLogSlot As Integer, ByRef pbInValue As Byte) As Long
Public Declare Function Aisa57OutPort Lib "aisa57" (ByVal wLogSlot As Integer, ByVal bOutValue As Byte) As Long
Public Declare Function Aisa57GetLastError Lib "aisa57" (ByVal wLogSlot As Integer) As Long
